#ifndef SERIAL_ANALYZER_RESULTS
#define SERIAL_ANALYZER_RESULTS

#include <AnalyzerResults.h>

class A7100Analyzer;
class A7100AnalyzerSettings;

class A7100AnalyzerResults : public AnalyzerResults
{
public:
    A7100AnalyzerResults(A7100Analyzer *analyzer, A7100AnalyzerSettings *settings);
    virtual ~A7100AnalyzerResults();

    virtual void GenerateBubbleText(U64 frame_index, Channel &channel, DisplayBase display_base);
    virtual void GenerateExportFile(const char *file, DisplayBase display_base, U32 export_type_user_id);

    virtual void GenerateFrameTabularText(U64 frame_index, DisplayBase display_base);
    virtual void GeneratePacketTabularText(U64 packet_id, DisplayBase display_base);
    virtual void GenerateTransactionTabularText(U64 transaction_id, DisplayBase display_base);

protected: //functions

protected:  //vars
    A7100AnalyzerSettings *mSettings;
    A7100Analyzer *mAnalyzer;
};

#endif //SERIAL_ANALYZER_RESULTS
