#ifndef SERIAL_ANALYZER_SETTINGS
#define SERIAL_ANALYZER_SETTINGS

#include <AnalyzerSettings.h>
#include <AnalyzerTypes.h>
#include <thread>

namespace A7100AnalyzerEnums
{
    enum Mode { Normal, MpModeMsbZeroMeansAddress, MpModeMsbOneMeansAddress };
};

class A7100AnalyzerSettings : public AnalyzerSettings

{
public:
    A7100AnalyzerSettings();
    virtual ~A7100AnalyzerSettings();

    virtual bool SetSettingsFromInterfaces();
    void UpdateInterfacesFromSettings();
    virtual void LoadSettings(const char *settings);
    virtual const char *SaveSettings();

    Channel mInputChannel1;
    Channel mInputChannel2;
    Channel mInputChannel3;
    U32 mBitRate = 16000000; // Pixelfrequenz 16Mhz
    bool screenVisible = false;
    int screenWidth = 800;
    int screenHeight = 600;
    U32 screenMap[800*600];
    bool calcDone = false;
    bool autoRefresh = false;


protected:
    std::unique_ptr< AnalyzerSettingInterfaceChannel >    mInputChannelInterface1;
    std::unique_ptr< AnalyzerSettingInterfaceChannel >    mInputChannelInterface2;
    std::unique_ptr< AnalyzerSettingInterfaceChannel >    mInputChannelInterface3;
    std::unique_ptr< AnalyzerSettingInterfaceBool >       mShowWindow;
    std::thread winThread;
    void WindowThread();
};

#endif //SERIAL_ANALYZER_SETTINGS
