#ifndef SERIAL_SIMULATION_DATA_GENERATOR
#define SERIAL_SIMULATION_DATA_GENERATOR

#include <AnalyzerHelpers.h>

class A7100AnalyzerSettings;

class A7100SimulationDataGenerator
{
public:
    A7100SimulationDataGenerator();
    ~A7100SimulationDataGenerator();

    void Initialize(U32 simulation_sample_rate, A7100AnalyzerSettings *settings);
    U32 GenerateSimulationData(U64 newest_sample_requested, U32 sample_rate, SimulationChannelDescriptor **simulation_channels);

protected:
    A7100AnalyzerSettings *mSettings;
    U32 mSimulationSampleRateHz;
    BitState mBitLow;
    BitState mBitHigh;

    U64 mLine;
    U64 mColum;

protected: //Serial specific

    ClockGenerator mClockGenerator;
    SimulationChannelDescriptorGroup mA7100SimulationData;
    SimulationChannelDescriptor *mSyn;
    SimulationChannelDescriptor *mDat1;
    SimulationChannelDescriptor *mDat2;
};

#endif //UNIO_SIMULATION_DATA_GENERATOR
